#include <iostream>

using namespace std;

class Acumulador {

public:
  Acumulador ();
  void operator () (double num);
  double getAcum () const;
private:

  double acum;

};

Acumulador::Acumulador () : acum(0) {
}

// El Operador () suma en la variable miembro lo que pasemos como argumento
void Acumulador::operator () (double num) {
  acum += num;
}

// Devuelve el valor acumulado hasta el momento
double Acumulador::getAcum () const {
  return acum;
}

int main (void) {

  Acumulador ac;

  cout << "Voy a sumar los numeros del 1 al 10 por medio de un objeto funcion." << endl;
  for (int i = 1; i <= 10; i++)
    ac(i);

  cout << "El valor acumulado hasta el momento es de: " << ac.getAcum() << endl;

  return 0;

}
