#include <iostream>

using namespace std;

void print (double n) {
  cout << n << endl;
}

// Si damos un valor por defecto a la variable s, entonces el
// primer print encajara con esta funcion.
//void print (int n, string s) {
void print (int n, string s = "defecto") {
  cout << n << " " << s << endl;
}

int main (void) {

  int i = 2;
  double d = 3.5;
  unsigned u = 1;
  string s = "hola";

  print (i);
  print (d);
  //  print (u);
  // Es necesario hacer un static_cast de la variable u para eliminar
  // la ambiguedad (el compilador no sabe si convertir de unsigned a double
  // o a int)
  print (static_cast<int> (u));
  print (i, s);
  print (d, s);
  print (u, s);

  return 0;

}
