#include <iostream>

using namespace std;

// Primero implemento la clase que representa al Objeto Funcion que
// evalua una condicion
class Evalua {

public:

  Evalua ();
  bool operator () (double x) const;

};

Evalua::Evalua () {
}

bool Evalua::operator () (double x) const {
  return ((int)x % 2 ) == 0;
}


// Ahora implemento una funcion que recibe un array de double, el tamano
// del array y el objeto funcion con el que se va a evaluar la condicion
// por cada elemento del array
void transform (double* arr, int tam, const Evalua& eval) {
  for (int i = 0; i < tam; i++)
    if (eval (arr[i]))
      cout << arr[i] << " ";
  cout << endl;
}

int main (void) {

  // Creo un array de double y lo relleno con numeros del 1 al 10
  double arr[10];

  for (int i = 0; i < 10; i++)
    arr[i] = i+1;

  cout << "Mi array es: ";
  for (int i = 0; i < 10; i++)
    cout << arr[i] << " ";
  cout << endl;

  // Creo un objeto funcion que me va a evaluar si un numero es par
  Evalua eval;

  // Ahora invoco a la funcion que recorre el array e imprime solo los
  // elementos que el objeto funcion diga que son pares
  cout << "Los numeros pares son: ";
  transform (arr, 10, eval);

  return 0;

}
