#include <iostream>

using namespace std;

double area (double base, double altura) {
  return (base * altura) / 2;
}

double area (double lado) {
  return lado * lado;
}

// No podemos sobrecargar la funcion que calcula el area de un
// circulo porque su prototipo coincide con el del area del
// triangulo (recibe dos double y devuelve un double)
double area_circulo (double radio, const double pi = 3.141592) {
  return pi * radio * radio;
}

// Lo mismo ocurre con el rectangulo
double area_rectangulo (double largo, double alto) {
  return largo * alto;
}

double area (double altura, double baseMayor, double baseMenor) {
  return (altura * (baseMayor + baseMenor)) / 2;
}

int main (void) {

  double base = 2;
  double altura = 3;
  double lado = 1.5;
  double radio = 3.7;
  double largo = 1.3;
  double alto = 2.9;
  double baseMayor = 7;
  double baseMenor = 3.5;

  double areaTriangulo = area (base, altura);
  double areaCuadrado = area (lado);
  double areaCirculo = area_circulo (radio);
  double areaRectangulo = area_rectangulo (largo, alto);
  double areaTrapecio = area (altura, baseMayor, baseMenor);

  cout << "El area del triangulo es: " << areaTriangulo << endl;
  cout << "El area del cuadrado es: " << areaCuadrado << endl;
  cout << "El area del circulo es: " << areaCirculo << endl;
  cout << "El area del rectangulo es: " << areaRectangulo << endl;
  cout << "El area del trapecio es: " << areaTrapecio << endl;

  return 0;

}
